// Resolution locked at 800x600
object_event_add(RoomChangeObserver,ev_other,ev_room_start,'
    global.customWidth = 800;
    global.customHeight = 600;
    // Copypasted from rooms_fix_views. We run it after room_goto_fix has been called and it does the thing again
    global.ingamewidth = global.customWidth;
    global.ingameheight = global.customHeight;
    var maprooms, nummaps;
    nummaps = 2;
    maprooms[0] = CustomMapRoom
    maprooms[1] = BuilderRoom
    for(i = 0; i < nummaps; i += 1)
    {
        room_set_view(maprooms[i], 0, true,
                      0, 0, global.ingamewidth, global.ingameheight, 
                      0, 0, global.ingamewidth, global.ingameheight,
                      0, 0, 0, 0, noone);
    }
');

// InGameElements   ====================================================================================================
// 50 hp sentry finishes building faster
object_event_add(Sentry, ev_create, 0, 'maxHp = 50;');
// Healthbar exposed by spy, reduced sandvich cooldown
object_event_add(Character, ev_create, 0, 'exposed = false; eatCooldown = 10*30;');
// Sandvich heals half as much, but cooldown is 10 seconds. Can be cancelled (subject to start/end lag)
object_event_add(Character, ev_step, ev_step_end, '  
    if (omnomnomnom)
    {
        if (hp < maxHp)
            hp -= .8 * global.delta_factor;
        if (omnomnomnomindex >= omnomnomnomend/5 and ((keyState | pressedKeys) & $08))
            omnomnomnomindex = max(omnomnomnomindex, omnomnomnomend * 4/5);
    }
');
// Draw healthbars for enemies exposed to spy
object_event_add(Character, ev_draw, 0, '
    exposed = false;
    with (Revolver)
        if (owner.team != other.team and not owner.cloak and distance_to_object(other) < 100)
            if not collision_line(x, y, other.x, other.y, Obstacle, true, true)
                other.exposed = true;
    if (not cloak and (global.myself.class == CLASS_SPY or exposed and team != global.myself.team)) 
    {
        var xr, yr;
        xr = round(x);
        yr = round(y);
        draw_set_alpha(1);
        draw_healthbar(xr-10, yr-30, xr+10, yr-25,hp*100/maxHp,c_black,c_red,c_green,0,true,true);
    }
');
// Generates rj particles if particles turned off
// Generate mores nuts and bolts
// Uber cancels and refunds sandvich
object_event_add(Character, ev_step, ev_step_begin, '
    if(moveStatus == 1 or moveStatus == 2 or moveStatus == 4)
        if(global.run_virtual_ticks)
            if(global.particles == PARTICLES_OFF)
                if(random(7) < 5)
                    part_particles_create(global.jumpFlameParticleSystem,x,y+19,jumpFlameParticleType,1);
    nutsNBolts = min(nutsNBolts+(0.1 * global.delta_factor), maxNutsNBolts);
    if (ubered and omnomnomnom) {
        omnomnomnomindex = max(omnomnomnomindex, omnomnomnomend * .9);
        alarm[6] = 1;
    }
');

// Classes          ====================================================================================================
// Heavy can move faster while shooting, especially when ubered
object_event_add(Heavy, ev_step, ev_step_normal, '
    if (keyState & $10){
        if ubered
            runPower = 0.8;
        else
            runPower = 0.5;
    }
');
// removes passive invisibility
object_event_clear(Spy, ev_step, ev_step_end);
// 127hp
object_event_add(Quote, ev_create, 0, 'maxHp = 127;');

// Weapons          ====================================================================================================
// 2.4 scattergun
object_event_clear(Scattergun, ev_other, ev_user3);
object_event_add(Scattergun, ev_other, ev_user3, '
    ammoCount = max(0, ammoCount-1);
    playsound(x,y,ShotgunSnd);
    var shot;
    repeat(6) {
        shot = createShot(x, y, Shot, DAMAGE_SOURCE_SCATTERGUN, owner.aimDirection, 13);
        if(golden)
            shot.sprite_index = ShotGoldS;
        shot.direction = owner.aimDirection + (random(15)-7);                                   // Pre-2.4.4 momentum inheritance
        shot.speed = 11 + random(4);
        shot.hspeed += owner.hspeed;
        // Move shot forward one 30fps step to avoid immediate collision with a wall behind the character
        // delta_factor is left out intentionally!
        shot.x += lengthdir_x(shot.speed, shot.direction);
        shot.y += lengthdir_y(shot.speed, shot.direction);
        shot.alarm[0] = 30 * ((min(1, abs(cos(degtorad(owner.aimDirection)))*13                 // Reduce shot lifetime
            / abs(cos(degtorad(owner.aimDirection))*13+owner.hspeed))-1)/2+1)
            / global.delta_factor;
    }
    justShot = true;
    readyToShoot = false;
    alarm[0] = refireTime / global.delta_factor;
    alarm[5] = (reloadBuffer + reloadTime) / global.delta_factor;
');

// flame sooner after airblasting 
object_event_add(Flamethrower, ev_create, 0, 'blastNoFlameTime /= 2;');

// Allow needling during uber
// Fill hp and ammo during uber
object_event_clear(Medigun, ev_other, ev_user2);
object_event_add(Medigun, ev_other, ev_user2, '
    // if (readyToShoot and !instance_exists(healTarget) and !ubering and ammoCount > 0)
    if (readyToShoot and !instance_exists(healTarget) and ammoCount > 0)
    {
        // Infinite ammo during uber
        if !ubering
            ammoCount -= 1;
        playsound(x,y,MedichaingunSnd);
        var shot;
        shot = createShot(x, y + yoffset + 1, Needle, DAMAGE_SOURCE_NEEDLEGUN, owner.aimDirection, 7+random(3));
        shot.hitDamage = 4;
        justShot=true;
        with(shot)
            hspeed+=owner.hspeed;
        readyToShoot=false;
        alarm[0] = refireTime / global.delta_factor;
        alarm[5] = (reloadBuffer + reloadTime) / global.delta_factor;
        alarm[7] = alarm[5] / 4;
    }
    else if (uberReady && (owner.keyState & $10))
    {   
        owner.hp = owner.maxHp;
        ammoCount = maxAmmo;
        if(global.isHost)
        {
            sendEventUber(ownerPlayer);
            doEventUber(ownerPlayer);
        }
    }
');

// sentry heals for 7.5 hp/s
object_event_add(SentryTurret, ev_draw, 0, '
    with (Character) {
        if (not cloak and team == other.team and distance_to_object(other) <= 100) {
            if not collision_line(x, y, other.x, other.y, Obstacle, true, true) {
                hp += .25 * global.delta_factor;
                var color;
                if(team == TEAM_RED)
                    color = c_red;
                else
                    color = c_blue;
                draw_set_alpha(0.3);
                draw_line_width_color(x, y, other.x, other.y, 3, color, color);
            }
        }
    }
');

// move while stabbing
object_event_add(Revolver, ev_other,ev_user1, 'if (owner.stabbing) owner.runPower = .4;');

// clearshot sightline
object_event_add(Rifle, ev_draw, 0, '
    if(owner.zoomed)
    {
        var x1, y1, xm, ym, leftmostX, len;
        len = 1500*(((hitDamage*100)/maxDamage)/100)
        x1 = x;
        y1 = y;
        x2 = x+lengthdir_x(len, owner.aimDirection);
        y2 = y+lengthdir_y(len, owner.aimDirection);
        leftmostX = min(x1, x2);

        gunSetSolids();
        var bulletStoppingObjects, originalMask, hitInstance;
        bulletStoppingObjects = ds_list_create();
        originalMask = ds_map_create();
        hitInstance = noone;

        ds_list_add(bulletStoppingObjects, Obstacle);
        ds_list_add(bulletStoppingObjects, Generator);
        ds_list_add(bulletStoppingObjects, Character);
        ds_list_add(bulletStoppingObjects, Sentry);
        if(!global.mapchanging)
            ds_list_add(bulletStoppingObjects, TeamGate);
        ds_list_add(bulletStoppingObjects, IntelGate);
        if(areSetupGatesClosed())
            ds_list_add(bulletStoppingObjects, ControlPointSetupGate);
        ds_list_add(bulletStoppingObjects, BulletWall);

        // Set the collision mask of all instances which should not collide to an empty one
        with(Generator) {
            if(team == other.owner.team) {
                ds_map_add(originalMask, id, mask_index);
                mask_index = emptyMaskS;
            }
        }

        with(Sentry) {
            if(team == other.owner.team) {
                ds_map_add(originalMask, id, mask_index);
                mask_index = emptyMaskS;
            }
        }

        with(owner) {
            ds_map_add(originalMask, id, mask_index);
            mask_index = emptyMaskS;
        }

        // Find the first instance the ray collides with
        var hit, i;
        while(len>1) {
            xm=(x1+x2)/2;
            ym=(y1+y2)/2;
            
            hit = noone;
            for(i = 0; (i < ds_list_size(bulletStoppingObjects)) and !hit; i += 1) {
                hit = collision_line(x1, y1, xm, ym, ds_list_find_value(bulletStoppingObjects, i), true, true);
            }
            
            if(hit) {
                x2=xm;
                y2=ym;
                hitInstance = hit;
            } else {
                x1=xm;
                y1=ym;
            }
            len/=2;
        }

        // Re-assign the original collision masks
        var key, origMask;
        for(key = ds_map_find_first(originalMask); key; key = ds_map_find_next(originalMask, key)) {
            origMask = ds_map_find_value(originalMask, key);
            with(key) {
                mask_index = origMask;
            }
        }

        ds_map_destroy(originalMask);
        ds_list_destroy(bulletStoppingObjects);

        draw_set_alpha(0.3);
        var laserColor;
        if (owner.team == TEAM_RED)
            laserColor = c_red;
        else
            laserColor = c_blue;
        draw_line_width_color(x,y,x2,y2,1,laserColor,laserColor);
        draw_set_alpha(1);
    }
');

// Projectiles      ====================================================================================================
// Flare and flame penetrate infinitely
object_event_add(Flame, ev_create, 0, 'penetrateCap = 99;');
object_event_add(Flare, ev_create, 0, 'penetrateCap = 99;');
// Bubbles do not block flare
object_event_clear(Flare, ev_collision, Bubble);
// Flares curve with gravity
object_event_add(Flare, ev_step, ev_step_normal, 'vspeed += .15;');
// Infinite multistab
object_event_add(StabMask, ev_create, 0, 'maxKills = 99;');
// No passive invisibility during stab
object_event_clear(StabAnim, ev_step, ev_step_end);
// bubbles do damage lmao
object_event_add(Bubble, ev_create, 0, 'hitDamage = 2;');
object_event_clear(Bubble, ev_collision, Mine);
object_event_clear(Bubble, ev_collision, BladeB);
object_event_add(Bubble, ev_collision, Character, '
    if (other.team == team and other.id != ownerPlayer.object)
    {
        other.hp += hitDamage;
        instance_destroy();
    }
');
// blades do a shitload more knockback
object_event_clear(BladeB, ev_collision, Character);
object_event_add(BladeB, ev_collision, Character, '
    if(other.id != ownerPlayer.object and other.team != team)
    {
        if(!other.ubered)
        { 
            damageCharacter(ownerPlayer, other.id, hitDamage);
            other.timeUnscathed = 0;
            if (other.lastDamageDealer != ownerPlayer and other.lastDamageDealer != other.player)
            {
                other.secondToLastDamageDealer = other.lastDamageDealer;
                other.alarm[4] = other.alarm[3]
            }
            other.alarm[3] = ASSIST_TIME / global.delta_factor;
            other.lastDamageDealer = ownerPlayer;
            other.lastDamageSource = weapon;
            var blood;
            if(global.gibLevel > 0)
            {
                repeat(25)
                {
                    blood = instance_create(x,y,Blood);
                    blood.direction = direction-180;
                }
            }
        }
        with(other)
            motion_add(other.direction, other.speed * 100 / maxHp);
        dealFlicker(other.id);
        
        instance_destroy();
    }
');
// ubered players bodyblock more
object_event_add(Shot,              ev_collision, Character, 'if other.team != team  && other.ubered instance_destroy();');
object_event_add(BurningProjectile, ev_collision, Character, 'if other.team != team  && other.ubered instance_destroy();');
object_event_add(Needle,            ev_collision, Character, 'if other.team != team  && other.ubered instance_destroy();');
// Blade can destroy/detonate everything
object_event_add(Rocket,            ev_collision, BladeB, 'if(team != other.team) event_user(5);');
object_event_add(Mine,              ev_collision, BladeB, 'if(team != other.team) event_user(2);');
object_event_add(Shot,              ev_collision, BladeB, 'if(team != other.team) instance_destroy();');
object_event_add(BurningProjectile, ev_collision, BladeB, 'if(team != other.team) instance_destroy();');
object_event_add(Needle,            ev_collision, BladeB, 'if(team != other.team) instance_destroy();');
object_event_add(BladeB,            ev_collision, BladeB, 'if(team != other.team) instance_destroy();');
// All classes can destroy stuck mines
object_event_add(Mine, ev_collision, Shot,              'if(team != other.team and stickied) instance_destroy();');
object_event_add(Mine, ev_collision, BurningProjectile, 'if(team != other.team and stickied) instance_destroy();');
object_event_add(Mine, ev_collision, Needle,            'if(team != other.team and stickied) instance_destroy();');
object_event_add(Mine, ev_collision, Bubble,            'if(team != other.team and stickied) instance_destroy();');
object_event_add(Mine, ev_collision, BladeB,            'if(team != other.team and stickied) instance_destroy();');
object_event_clear(Mine, ev_draw, 0);
object_event_add(Mine, ev_draw, 0, '
    draw_sprite_ext(sprite_index,owner.team*2 + (animationState or (stickied and owner.team != global.myself.team)),x,y,image_xscale,image_yscale,0,c_white,1 - .7*(stickied and owner.team != global.myself.team));
');
object_event_add(Rocket, ev_create, 0, '
    hitDamage = 20;
    explosionDamage = 40;
    // blastRadius = 65;
');
object_event_clear(Rocket, ev_other, ev_user5);
object_event_add(Rocket, ev_other, ev_user5, '
    if(characterHit.id != ownerPlayer.object)
    {
        if(exploded)
            exit;
        else
            exploded = true;
        if(characterHit != -1) {
            if(characterHit.team != team || characterHit.id == ownerPlayer.object and !characterHit.ubered )
            {
                damageAuto( ownerPlayer, characterHit, hitDamage );
                if object_is_ancestor(characterHit.object_index, Character)
                {
                    if (characterHit.lastDamageDealer != ownerPlayer and characterHit.lastDamageDealer != characterHit.player)
                    {
                        characterHit.secondToLastDamageDealer = characterHit.lastDamageDealer;
                        characterHit.alarm[4] = characterHit.alarm[3]
                    }
                    characterHit.alarm[3] = ASSIST_TIME / global.delta_factor;
                }
                characterHit.lastDamageDealer = ownerPlayer;
                characterHit.lastDamageSource = weapon;
            }
        }
        instance_create(x,y,Explosion);
        playsound(x,y,ExplosionSnd);

        with (Character) {            
            if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.ownerPlayer.object and place_meeting(x, y+1, Obstacle))){                
                                var x0, y0;
                                x0 = other.x-other.hspeed/global.delta_factor;
                                y0 = other.y-other.vspeed/global.delta_factor;
                                if collision_line(x, y, x0, y0, Obstacle, true, true)
                                    continue;
                var rdir, vectorfactor;
                rdir = point_direction(other.x, other.y, x+(left_bound_offset+right_bound_offset)/2, y+(top_bound_offset+bottom_bound_offset)/2);
                vectorfactor = point_distance(0, 0, power(sin(degtorad(rdir)), 2), power(cos(degtorad(rdir)), 2));
                var fake_distance;
                fake_distance = distance_to_object(other);
                if(fake_distance < 1) fake_distance = 0; // fix distance of rockets to players that they collide with, now that its handled properly
                if (1 - fake_distance/other.blastRadius <= 0.25)
                    continue;
                motion_add(rdir, min(15, other.knockback-other.knockback*(fake_distance/other.blastRadius)) * vectorfactor);
                if(!ubered and hp > 0)
                {
                    if (other.team != team) or (id==other.ownerPlayer.object)
                    {
                                        var dmg, tiers;
                                        dmg = other.explosionDamage*(1-fake_distance/other.blastRadius);
                                        tiers = 2;
                                        dmg = round(.25 + tiers * dmg/other.explosionDamage) / tiers * other.explosionDamage;
                                        // if (id==other.ownerPlayer.object)
                                        //     dmg = min(30, dmg);
                                        damageCharacter(other.ownerPlayer, id, dmg);
                        if(id == other.ownerPlayer.object and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer)
                            lastDamageSource = DAMAGE_SOURCE_FINISHED_OFF_GIB;
                        else 
                        {
                            if (lastDamageDealer != other.ownerPlayer && lastDamageDealer != player){
                                secondToLastDamageDealer = lastDamageDealer;
                                alarm[4] = alarm[3]
                            }
                            if (other.ownerPlayer != id)
                                alarm[3] = ASSIST_TIME / global.delta_factor;
                            lastDamageDealer = other.ownerPlayer;
                            lastDamageSource = other.weapon;
                        }
                        dealFlicker(id);
                    }
                    if id==other.ownerPlayer.object and other.team == team {
                        moveStatus = 1;
                        speed*=1.06;
                    }else if other.team == team and (id!=other.ownerPlayer.object){
                        moveStatus = 4;
                            if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(fake_distance/other.blastRadius));
                            speed*=1.3;
                        }
                    } else {
                        moveStatus = 2;
                        if point_direction(x,y+5,other.x,other.y-5)>210 and point_direction(x,y,other.x,other.y)<330 {
                            vspeed-=4*(1-(fake_distance/other.blastRadius));
                            speed*=1.3;
                        }
                    }
                    if(global.gibLevel > 0) {
                        if (id==other.ownerPlayer.object) or (other.team!=team) {
                            repeat(3) {
                                var blood;
                                blood = instance_create(x,y,Blood);
                                blood.direction = point_direction(other.x,other.y,x,y)-180;
                            }
                        }
                    }
                }
            }
        }

        with (Sentry)
            if (distance_to_object(other) < other.blastRadius/2) and (team != other.team) {
                damageSentry( other.ownerPlayer, id, other.explosionDamage*3/2);
                lastDamageDealer = other.ownerPlayer;
                lastDamageSource = other.weapon;
            }  
        with (Gib)
            if (distance_to_object(other) < other.blastRadius){
                motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.blastRadius));
                rotspeed=random(151)-75;
            }
        with (Generator)    if (distance_to_object(other) < other.blastRadius) and  (other.team != team) damageGenerator( other.ownerPlayer, id, other.explosionDamage );
        with (DeadGuy)      if (distance_to_object(other) < other.blastRadius) motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        with (Mine)         if (distance_to_object(other) < other.blastRadius*0.66 and (other.team != team or other.ownerPlayer == ownerPlayer))    event_user(2);
        with (LooseSheet)   if (distance_to_object(other) < other.blastRadius) motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.blastRadius));
        with (Bubble)       if (distance_to_object(other) < other.blastRadius*0.66) instance_destroy();

        instance_destroy();
    }
');
object_event_add(Mine, ev_create, 0, '
    explosionDamage = 40;
    stickiedBonusDamage = 20;
    // blastRadius = 40;
');
object_event_clear(Mine, ev_other, ev_user2);
object_event_add(Mine, ev_other, ev_user2, '
    if(exploded == true) {
        exit;
    } else {
        exploded = true;
    }
    var explosion;
    explosion = instance_create(x,y,Explosion);
    explosion.sprite_index = ExplosionSmallS;
    playsound(x,y,ExplosionSnd);
    
    with (Character) {
        if (distance_to_object(other) < other.blastRadius and !(team == other.team and id != other.ownerPlayer.object and place_meeting(x, y+1, Obstacle)))
        {                   
                            var x0, y0;
                            x0 = other.x-other.hspeed/global.delta_factor;
                            y0 = other.y-other.vspeed/global.delta_factor;
                            if collision_line(x, y, x0, y0, Obstacle, true, true)
                                continue;
            var rdir, vectorfactor;
            rdir = point_direction(other.x, other.y, x+(left_bound_offset+right_bound_offset)/2, y+(top_bound_offset+bottom_bound_offset)/2);
            vectorfactor = point_distance(0, 0, sin(degtorad(rdir)), cos(degtorad(rdir))*0.8);
            if (1 - distance_to_object(other)/other.blastRadius <= 0.25 and other.splashThreshhold) // skip if we are out of theshhold
                continue;
            motion_add(rdir, min(15, other.knockback-other.knockback*(distance_to_object(other)/other.blastRadius)) * vectorfactor);
            if((other.team != team or id==other.ownerPlayer.object) and !ubered and hp > 0)
                            {
                                var dmg, tiers;
                                dmg = other.explosionDamage*(1-distance_to_object(other)/other.blastRadius);
                                tiers = 2;
                                dmg = round(.25 + tiers * dmg/other.explosionDamage) / tiers * other.explosionDamage;
                                dmg += other.stickiedBonusDamage*other.stickied;
                                damageCharacter(other.ownerPlayer, id, dmg);
                // if id == other.ownerPlayer.object// self damage resistance
                //     dmg *= 5/9;
                timeUnscathed = 0;
                if (id == other.ownerPlayer.object and instance_exists(lastDamageDealer) and lastDamageDealer != other.ownerPlayer and !instance_exists(other.reflector))
                    lastDamageSource = DAMAGE_SOURCE_FINISHED_OFF_GIB;
                else 
                {
                    if (lastDamageDealer != other.ownerPlayer and lastDamageDealer != player and other.reflector != lastDamageDealer)
                    {
                        secondToLastDamageDealer = lastDamageDealer;
                        alarm[4] = alarm[3]
                    }
                    if (other.ownerPlayer != id or (instance_exists(other.reflector) and other.ownerPlayer == id))
                        alarm[3] = ASSIST_TIME / global.delta_factor;
                    lastDamageDealer = other.ownerPlayer;
                    lastDamageSource = other.weapon;
                    if (id==other.ownerPlayer.object and instance_exists(other.reflector))
                    {
                        lastDamageDealer = other.reflector;
                        lastDamageSource = DAMAGE_SOURCE_REFLECTED_STICKY;
                    }
                }
                if(global.gibLevel > 0)
                {
                    repeat(3)
                    {
                        var blood;
                        blood = instance_create(x,y,Blood);
                        blood.direction = point_direction(other.x,other.y,x,y)-180;
                    }
                }
                if (id==other.ownerPlayer.object)
                    moveStatus = 1;
                else if (other.team == team)
                    moveStatus = 2;
                else
                    moveStatus = 4;
            }
            dealFlicker(id);
        }
    }

    with (Sentry)
        if (distance_to_object(other) < other.blastRadius/2) and (team != other.team) {
            damageSentry(other.ownerPlayer, id, other.explosionDamage*3/2);
            lastDamageDealer = other.ownerPlayer;
            lastDamageSource = DAMAGE_SOURCE_MINEGUN;
        }
    with (Rocket)
        if (distance_to_object(other) < other.affectRadius/2 and (other.team != team or other.ownerPlayer == ownerPlayer))
        {
            characterHit = -1;
            event_user(5);
        }
    with (Gib)
        if (distance_to_object(other) < other.affectRadius * 0.75)
        {
            motion_add(point_direction(other.x,other.y,x,y),15-15*(distance_to_object(other)/other.affectRadius));
            rotspeed=random(151)-75;
        }
    with (Generator)    if (distance_to_object(other) < other.blastRadius and team != other.team) damageGenerator(other.ownerPlayer, id, other.explosionDamage*(1-(distance_to_object(other)/other.blastRadius)));
    with (Mine)         if (distance_to_object(other) < other.blastRadius and (other.team != team or other.ownerPlayer == ownerPlayer)) event_user(2);
    with (DeadGuy)      if (distance_to_object(other) < other.affectRadius * 0.75) motion_add(point_direction(other.x,other.y,x,y),10-10*(distance_to_object(other)/other.affectRadius));
    with (LooseSheet)   if (distance_to_object(other) < other.affectRadius * 0.75) motion_add(point_direction(other.x, other.y, x, y) ,10-10*(distance_to_object(other)/other.affectRadius));
    with (Bubble)       if (distance_to_object(other) < other.blastRadius + selfPopRadius) instance_destroy();

    instance_destroy();
');